extends Spatial
class_name Propeller

onready var prop_mesh = $Mesh
onready var prop_blade1 = $Mesh/Blade1
onready var prop_blade2 = $Mesh/Blade2
onready var prop_multi = $Mesh/PropMultiMesh
onready var prop_hub = $Mesh/Hub
onready var prop_multihub = $Mesh/HubMultiMesh
var prop_mat = load("res://PropMat.tres")
var hub_mat = load("res://HubMat.tres")

export (float, 0, 10000) var rpm = 100
export (float, 0, 90) var pitch = 20
export (int, 1, 200) var instances = 10
export (float, 0, 0.5) var spread = 0.1


func _ready():
	prop_blade1.visible = false
	prop_blade2.visible = false
	prop_multi.visible = true
#	prop_hub.visible = false
#	prop_multihub.visible = true


func _process(delta):
	prop_blade1.transform = Transform.IDENTITY.rotated(Vector3.RIGHT, deg2rad(pitch)).translated(Vector3(0.5, 0, 0))
	prop_blade2.transform = prop_blade1.transform.rotated(Vector3.FORWARD, PI)
	
	prop_mesh.rotate_object_local(Vector3.FORWARD, PI * rpm / 30 * delta)
	
	var opacity = 1.0 / sqrt(instances)
	prop_mat.albedo_color.a = 0.1
#	hub_mat.albedo_color.a = opacity
	
	
	var copies = 2 * instances
	prop_multi.multimesh.instance_count = copies
#	prop_multihub.multimesh.instance_count = instances
	var rot = rpm * spread / copies / 10
	for i in range(copies):
		if i < copies / 2:
			prop_multi.multimesh.set_instance_transform(i,
					prop_blade1.transform.rotated(Vector3.FORWARD, rot * i))
#			prop_multihub.multimesh.set_instance_transform(i,
#					prop_hub.transform.rotated(Vector3.FORWARD, rot * i))
		else:
			prop_multi.multimesh.set_instance_transform(i,
					prop_blade2.transform.rotated(Vector3.FORWARD, rot * (i - copies / 2)))
